package com.manalejandro.mongodbcrud;

import java.util.ArrayList;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.data.mongodb.repository.config.EnableMongoRepositories;

import com.manalejandro.mongodbcrud.model.Item;
import com.manalejandro.mongodbcrud.services.ItemService;

@SpringBootApplication
@EnableMongoRepositories(basePackages = { "com.manalejandro.mongodbcrud.repositories" })
public class MongodbcrudApplication implements CommandLineRunner {

	private ItemService itemService;
	private Logger logger;

	@Autowired
	public MongodbcrudApplication(ItemService itemService) {
		this.itemService = itemService;
		this.logger = LoggerFactory.getLogger(this.getClass());
	}

	public static void main(String[] args) {
		SpringApplication.run(MongodbcrudApplication.class, args);
	}

	public void run(String... args) throws Exception {
		ArrayList<Item> items = new ArrayList<Item>();
		for (int i = 1; i <= 10; i++) {
			items.add(new Item("nombre_" + i, "apellido1_" + i, "apellido2_" + i));
		}
		if (this.itemService.saveAll(items)) {
			this.logger.info("Datos de prueba cargados correctamente...");
		} else {
			this.logger.error("Error: No se han podido cargar los datos");
		}
	}
}
